package WebCoso::Cleaner;
use strict;
use warnings;
use File::Next;
use Path::Class;
use WebCoso::Common;
use Log::Log4perl ':easy';

sub clean {
    my %to_keep;
    @to_keep{WebCoso::Common::keepEarliest(WebCoso::Common::fromTo($WebCoso::Common::SRCPATH,{%WebCoso::Common::docfiles,dirs=>sub{!m{^(_webcoso|\.svn)$}}}))}=();
    @to_keep{WebCoso::Common::fromTo($WebCoso::Common::SRCPATH,{files=>sub{!m{^document\.}},dirs=>sub{!m{^(_webcoso|\.svn)$}}})}=();

    my $iter=File::Next::files({descend_filter=>sub{!m{^\.svn$}}},$WebCoso::Common::SRCPATH,$WebCoso::Common::DSTPATH);
    while (defined (my $file=$iter->())) {
        DEBUG("Examining $file");
        next if exists $to_keep{$file};
        INFO("Removing $file");
        unlink $file;
    }
    INFO("Removing $WebCoso::Common::DSTPATH");
    dir($WebCoso::Common::DSTPATH)->rmtree;
    INFO("Removing $WebCoso::Common::SRCPATH/_webcoso");
    dir($WebCoso::Common::SRCPATH,'_webcoso')->rmtree;
}

1;
